<?php
class XmlparserComponent extends Object
{

	function start_tag($parser, $name, $attribs) {
	   echo "Current tag : ".$name."<br />";
	   if (is_array($attribs)) {
	      echo "Attributes : <br />";
	      while(list($key,$val) = each($attribs)) {
	         echo "Attribute ".$key." has value ".$val."<br />";
	       }
	    }
	}
	
	
	
	
	function end_tag($parser, $name) {
  		echo "Reached ending tag ".$name."<br /><br />";
	}
	
	
	
	function createparser($filename){
		if (! ($xmlparser = xml_parser_create()) )
		{
			die ("Cannot create parser");
		} else {
			echo "By jove I've done it";
		} 
		
		if (!($fp = fopen($filename, "r"))) { die("cannot open ".$filename); }
		
		while ($data = fread($fp, 4096)){
			$data=eregi_replace(">"."[[:space:]]+"."< ",">< ",$data);
			if (!xml_parse($xmlparser, $data, feof($fp))) {
				$reason = xml_error_string(xml_get_error_code($xmlparser));
				$reason .= xml_get_current_line_number($xmlparser);
				die($reason);
			}
		}
		xml_parser_free($xmlparser);
		//xml_set_element_handler($xmlparser, "start_tag", "end_tag");
		//xml_set_character_data_handler($xmlparser, "tag_contents");
	}
	
	
	
	function tag_contents($parser, $data) {
		echo "Contents : ".$data."<br />";
	}
	
	function getxml($data, $destinationHost, $destinationURL){
		$directone_url = $destinationHost.$destinationURL; 

		// this is the path to your CURL library 
		$curl = "curl";  
		
		exec("$curl -Gd \"$data\" $directone_url", $return_string); 
		//echo "$curl -Gd \"$data\" $directone_url"; 
		
		return($return_string); 
	}




	function superParse($data) {
		if (!function_exists('sp_startElement')) {

			function sp_startElement($parser, $name, $attribs) {
				global $sp_xmlrow, $sp_depth, $sp_vals;
				
				$GLOBALS['sp_catdata'] = '';
				$sp_xmlrow++;
				$sp_vals[$sp_xmlrow]['name'] = strtolower($name);
				$sp_vals[$sp_xmlrow]['depth'] = $sp_depth;
				if ($attribs) {
					$sp_vals[$sp_xmlrow]['attribs'] = $attribs;
				}
				$sp_depth++;
			}
			
			function sp_endElement($parser, $name) 
			{
				global $sp_xmlrow, $sp_depth, $sp_vals;
			
				$sp_depth--;
				
				if ($data = trim($GLOBALS['sp_catdata'])) {
					$sp_vals[$sp_xmlrow]['value'] = $data;
				}
			}
			
			function sp_elementData($parser, $data) {
				global $sp_xmlrow, $sp_depth, $sp_vals;

				if (!empty($data) ) {
					$GLOBALS['sp_catdata'] .= $data;
				}
			}
		}		
		
		$xml_parser = xml_parser_create('UTF-8');
		xml_set_element_handler($xml_parser, "sp_startElement", "sp_endElement");
		xml_set_character_data_handler($xml_parser, 'sp_elementData');
		
		global $sp_xmlrow, $sp_depth, $sp_vals;
		
		$sp_xmlrow = -1;
		$sp_depth = 0;
		$sp_vals = array();
		
		if (!xml_parse($xml_parser, $data, true)) {
			/*
			die(sprintf("XML error: %s at line %d",
						xml_error_string(xml_get_error_code($xml_parser)),
						xml_get_current_line_number($xml_parser)));
			*/
			return false;
		}
		xml_parser_free($xml_parser);
		return $sp_vals;
	}

	function xmlExtract($data, $maintag, $filter=array()) {
		/*
			extracts the child tags in a given main tag from an xmlparser->superParse'd data
			the grandchildren (deeper level) tags are also treated as 1st level children
		*/
	
		$ret = array();

		for($i=0; $i<count($data); $i++) {
			if ($data[$i]['name'] == $maintag) {
				$d = $data[$i]['depth'] + 1;
				$add = array();
				
				if (isset($data[$i]['attribs'])) {
					$add['attribs'] = $data[$i]['attribs'];
				}
				while (@$data[++$i]['depth'] >= $d) {
					if (isset($data[$i]['value'])) {
						if (array_key_exists($data[$i]['name'], $filter) && $filter[$data[$i]['name']] != $data[$i]['value']) {
							continue 2;
						}
						if (isset($add[$data[$i]['name']])) {
							if (!is_array($add[$data[$i]['name']])) {
								// arrayise
								$add[$data[$i]['name']] = array($add[$data[$i]['name']]);
							}
							// append
							$add[$data[$i]['name']][] = $data[$i]['value'];
						} else {
							// if single, just put the value
							$add[$data[$i]['name']] = $data[$i]['value'];
						}
					}

					// attributes
					if (isset($data[$i]['attribs'])) {
						$add[$data[$i]['name'].'_attribs'][] = $data[$i]['attribs'];
					}

				}
				$i--;
				$ret[] = $add;
			}
		}
		return $ret;
	}
  
	function findFirstIndex($arr, $key, $startFrom = 0) {
		if (!is_array($arr))
			return false;

		for($i = $startFrom; $i<count($arr); $i++) {
			if (strtolower($arr[$i]['name']) == strtolower($key)) {
				return $i;
			}
		}
		return false;
	}
	
	function findFirstItem($arr, $key, $startFrom = 0) {
		if ( (($r = $this->findFirstIndex($arr, $key, $startFrom)) === false) || !array_key_exists('value', $arr[$r]) )
			return false;
		return $arr[$r]['value'];
	}


}
